; /**********************************************************************/
; /*								       	*/
; /*		     	 .			       	*/
; /*									*/
; /**********************************************************************/

						NAME    KEYBOARD_DRIVER

KEY_RELEASED		EQU		-1
KEY_NO_CHANGE		EQU		 0
KEY_PRESSED			EQU		 1

Enter_Key	   BIT		082H	;   "" - P0.2
Left_Key	   BIT		080H	;   "" - P0.0
Right_Key      	BIT		081H	;   "" - P0.1

KEYBOARD_CODE		SEGMENT	CODE
KEYBOARD_DATA		SEGMENT	DATA
KEYBOARD_BIT		SEGMENT	BIT

						PUBLIC  Init_Keyboard
						PUBLIC  Enter_Key_State
						PUBLIC  Left_Key_State
						PUBLIC  Right_Key_State

T2CON   	DATA    0C8H	;   .
T2MOD   	DATA    0C9H	;    2.
RCAP2L		DATA	0CAH	;      2.
RCAP2H		DATA	0CBH	;      2.
TL2    		DATA    0CCH	;    .
TH2    		DATA    0CDH	;    .
IE     		DATA    0A8H	;   .
ET2    		BIT     0ADH	;      2.
EA		BIT	0AFH	;    .

		CSEG	AT	0002BH	;     2.
		LJMP	Keyboard


			RSEG  KEYBOARD_BIT
Enter_Key_Prev_State:	DBIT	1;    "" =0 - .
Left_Key_Prev_State:	DBIT	1;    "" =0 - .
Right_Key_Prev_State:	DBIT	1;    "" =0 - .

						RSEG  KEYBOARD_DATA
Enter_Key_State:	DS	1	;    "".
Left_Key_State: 	DS	1	;    "".
Right_Key_State:	DS	1	;    "".

						RSEG	KEYBOARD_CODE
						USING   0

; /*************************************************************************/
; /*								       	     */
; /*			 	   . */
; /*									     */
; /* void Init_Keyboard(void)						     */
; /* :		  .				     */
; /* :		  .			     */
; /*								       	     */
; /*************************************************************************/
Init_Keyboard:

   ;      .
		  MOV		 A,#KEY_NO_CHANGE
   	  MOV		 Enter_Key_State,A
   	  MOV		 Left_Key_State,A
     	  MOV		 Right_Key_State,A

		  MOV		 C,Enter_Key
		  MOV		 Enter_Key_Prev_State,C

		  MOV		 C,Left_Key
		  MOV		 Left_Key_Prev_State,C

		  MOV		 C,Right_Key
		  MOV		 Right_Key_Prev_State,C

   ;     50 .
		  MOV		 A,#0B0H
   	  MOV		 TL2,A
   	  MOV		 RCAP2L,A

   	  MOV		 A,#03CH
   	  MOV		 TH2,A
   	  MOV		 RCAP2H,A

	;  ,   ,   .
	     MOV		 T2MOD,#000H
		  MOV		 T2CON,#004H

	;    2 .
		  SETB	 ET2
		  
		  RET


; /*************************************************************************/
; /*									   */
; /*        2 -  .      */
; /*									   */
; /*************************************************************************/
Keyboard:

  ;      .
        PUSH    ACC
        PUSH    PSW

  ;-------------------------------------------------------------------------;
  ; ,     "".			    ;
is_Enter_Key:
		  MOV		 C,Enter_Key
		  JC		 Enter_Key_Released

  ;    P1.0
  		  CPL		 090H

  ;  "" .
Enter_Key_Pressed:
		  JNB		 Enter_Key_Prev_State,End_Enter_Key
  ;  ""   .
  ;     "KEY_PRESSED".
  		  MOV		 Enter_Key_State,#KEY_PRESSED
  		  SJMP	 End_Enter_Key

  ;  "" .
Enter_Key_Released:
		  JB		 Enter_Key_Prev_State,End_Enter_Key
  ;  ""   .
  ;     "KEY_RELEASED".
  		  MOV		 Enter_Key_State,#KEY_RELEASED

  ;    "".
End_Enter_Key:
		  MOV		 Enter_Key_Prev_State,C

  ;-------------------------------------------------------------------------;
  ; ,     "".			    ;
is_Left_Key:
		  MOV		 C,Left_Key
		  JC		 Left_Key_Released

  ;  "" .
Left_Key_Pressed:
		  JNB		 Left_Key_Prev_State,End_Left_Key
  ;  ""   .
  ;     "KEY_PRESSED".
  		  MOV		 Left_Key_State,#KEY_PRESSED
  		  SJMP	 End_Left_Key

  ;  "" .
Left_Key_Released:
		  JB		 Left_Key_Prev_State,End_Left_Key
  ;  ""   .
  ;     "KEY_RELEASED".
  		  MOV		 Left_Key_State,#KEY_RELEASED

  ;    "".
End_Left_Key:
		  MOV		 Left_Key_Prev_State,C

  ;-------------------------------------------------------------------------;
  ; ,     "".			    ;
is_Right_Key:
		  MOV		 C,Right_Key
		  JC		 Right_Key_Released

  ;  "" .
Right_Key_Pressed:
		  JNB		 Right_Key_Prev_State,End_Right_Key
  ;  ""   .
  ;     "KEY_PRESSED".
  		  MOV		 Right_Key_State,#KEY_PRESSED
  		  SJMP	 End_Right_Key

  ;  "" .
Right_Key_Released:
		  JB		 Right_Key_Prev_State,End_Right_Key
  ;  ""   .
  ;     "KEY_RELEASED".
  		  MOV		 Right_Key_State,#KEY_RELEASED

  ;    "".
End_Right_Key:
		  MOV		 Right_Key_Prev_State,C

  ;-------------------------------------------------------------------------;
  ;       2.
  		  ANL		 T2CON,#07FH

  ;      .
Keyboard_End:
        POP     PSW
        POP     ACC
        RETI    

; /*************************************************************************/
        END












































